From b96f6eee158de1599ab70a74b2422ca7dbb8962f Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:54:10 +0000
Subject: [PATCH 704/1001] Create a base class for widgets


---

diff --git a/hubs/tests/test_widget_base.py b/hubs/tests/test_widget_base.py
new file mode 100644
index 0000000..fd6b3b3
--- /dev/null
+++ b/hubs/tests/test_widget_base.py
@@ -0,0 +1,110 @@
+from __future__ import unicode_literals
+
+from hubs.widgets.base import Widget
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.view import WidgetView
+
+from mock import Mock
+from hubs.tests import APPTest
+#import hubs.models
+
+
+class TestingWidget(Widget):
+    name = "testing"
+
+class TestingView(WidgetView):
+    name = "root"
+
+class TestingFunction(CachedFunction):
+    pass
+
+
+class WidgetTest(APPTest):
+
+    def setUp(self):
+        super(WidgetTest, self).setUp()
+        # Backup the URL map
+        self._old_url_map = (
+            self.app.application.url_map._rules[:],
+            self.app.application.url_map._rules_by_endpoint.copy()
+            )
+
+    def tearDown(self):
+        # Restore the URL map
+        self.app.application.url_map._rules = self._old_url_map[0]
+        self.app.application.url_map._rules_by_endpoint = self._old_url_map[1]
+        super(WidgetTest, self).tearDown()
+
+    def test_validate(self):
+        class LocalTestWidget(Widget):
+            views = {}
+            def get_views(self):
+                return self.views
+        test_widget = LocalTestWidget()
+        self.assertRaisesRegexp(
+            AttributeError, '.* "name" .*', test_widget.validate)
+        test_widget.name = "învalid næme"
+        self.assertRaisesRegexp(
+            AttributeError, '^Invalid widget name: ', test_widget.validate)
+        test_widget.name = "localtest"
+        self.assertRaisesRegexp(
+            AttributeError, '.* "position" .*', test_widget.validate)
+        test_widget.position = "invalid"
+        self.assertRaisesRegexp(
+            AttributeError, '.* "position" .*', test_widget.validate)
+        test_widget.position = "both"
+        self.assertRaisesRegexp(
+            AttributeError, '.* "root" .*', test_widget.validate)
+        test_widget.views["root"] = Mock()
+        test_widget.views["root"].url_rules = ["/invalid"]
+        self.assertRaisesRegexp(
+            AttributeError, '.* "/" .*', test_widget.validate)
+        test_widget.views["root"].url_rules = ["/"]
+        try:
+            test_widget.validate()
+        except AttributeError as e:
+            self.fail(e)
+
+    def test_list_views(self):
+        testing_widget = TestingWidget()
+        self.assertEqual(
+            testing_widget.get_views(),
+            {"root": TestingView}
+            )
+
+    def test_list_functions(self):
+        testing_widget = TestingWidget()
+        self.assertEqual(
+            testing_widget.get_cached_functions(),
+            {"TestingFunction": TestingFunction}
+            )
+
+    def test_list_views(self):
+        class TestView1(WidgetView):
+            name = "root"
+            url_rules = ["/", "/test-1/"]
+        class TestView2(WidgetView):
+            name = "test2"
+            url_rules = ["/test-2"]
+        testing_widget = TestingWidget()
+        testing_widget.get_views = Mock()
+        testing_widget.get_views.return_value = {
+            "root": TestView1(testing_widget),
+            "test2": TestView2(testing_widget),
+        }
+        testing_widget.register_routes(self.app.application)
+        # TestView1
+        self.assertIn("testing_root",
+                      self.app.application.url_map._rules_by_endpoint)
+        self.assertIn("testing_root", self.app.application.view_functions)
+        rules = list(self.app.application.url_map.iter_rules(endpoint="testing_root"))
+        self.assertEqual(len(rules), 2)
+        self.assertEqual(rules[0].rule, "/<hub>/w/testing/<int:idx>/")
+        self.assertEqual(rules[1].rule, "/<hub>/w/testing/<int:idx>/test-1/")
+        # TestView2
+        self.assertIn("testing_test2",
+                      self.app.application.url_map._rules_by_endpoint)
+        self.assertIn("testing_test2", self.app.application.view_functions)
+        rules = list(self.app.application.url_map.iter_rules(endpoint="testing_test2"))
+        self.assertEqual(len(rules), 1)
+        self.assertEqual(rules[0].rule, "/<hub>/w/testing/<int:idx>/test-2")
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
old mode 100755
new mode 100644
index 581532e..ecccf46
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -1,117 +1,129 @@
-from __future__ import unicode_literals
+from __future__ import unicode_literals, absolute_import
 
 import collections
-import datetime
-import functools
-import hashlib
-import json
-import sys
+import logging
+import re
 
-import dogpile.cache
-import flask
-import six.moves.urllib_parse
+from importlib import import_module
+from .caching import CachedFunction
+from .view import WidgetView
 
-import fedmsg.config
 
-import logging
 log = logging.getLogger(__name__)
 
-config = fedmsg.config.load_config()
-cache_defaults = {
-    "backend": "dogpile.cache.dbm",
-    "expiration_time": 1,  # Expire every 1 second, for development
-    "arguments": {
-        "filename": "/var/tmp/fedora-hubs-cache.db",
-    },
-}
-cache = dogpile.cache.make_region()
-cache.configure(**config.get('fedora-hubs.cache', cache_defaults))
-
-
 Argument = collections.namedtuple(
-    'Argument', ('name', 'default', 'validator', 'help'))
-
-
-def argument(name, default, validator, help):
-    def decorator(func):
-        @wraps(func)
-        def inner(*args, **kwargs):
-            return func(*args, **kwargs)
-
-        inner.widget_arguments.append(Argument(name, default, validator, help))
-        return inner
-    return decorator
-
-
-def AGPLv3(name):
-    def decorator(func):
-        @wraps(func)
-        def inner(session, widget, *args, **kwargs):
-            result = func(session, widget, *args, **kwargs)
-            result['source_url'] = flask.url_for('widget_source', name=name)
-            result['widget_url'] = flask.url_for(
-                'widget_render', hub=widget.hub.name, idx=widget.idx)
-            result['edit_url'] = flask.url_for(
-                'widget_edit', hub=widget.hub.name, idx=widget.idx)
-            result['widget'] = widget
-            return result
-
-        return inner
-    return decorator
-
-
-def smartcache(func):
-    @wraps(func)
-    def inner(session, widget, *args, **kwargs):
-        key = cache_key_generator(widget, *args, **kwargs)
-        creator = lambda: func(session, widget, *args, **kwargs)
-        #log.debug("Accessing cache key %s", key)
-        return cache.get_or_create(key, creator)
+    'Argument', ('name', 'label', 'default', 'validator', 'help'))
 
-    return inner
 
-
-def invalidate_cache(widget, *args, **kwargs):
-    key = cache_key_generator(widget, *args, **kwargs)
-
-    value = cache.get(key, ignore_expiration=True)
-    if isinstance(value, dogpile.cache.api.NoValue):
-        log.debug("Not deleting cache key %s.  It is absent.", key)
-        return
-
-    widget.hub.last_refreshed = datetime.datetime.utcnow()
-    log.debug("Deleting cache key %s.", key)
-    cache.delete(key)
-
-
-def cache_key_generator(widget, *args, **kwargs):
-    return "|".join([
-        str(widget.idx),
-        json.dumps(args),
-        json.dumps(kwargs),
-    ]).encode('utf-8')
-
-
-def wraps(original):
-    @functools.wraps(original)
-    def decorator(subsequent):
-        subsequent = functools.wraps(original)(subsequent)
-        subsequent.widget_arguments = getattr(original, 'widget_arguments', [])
-        return subsequent
-    return decorator
-
-
-def widget_route(**options):
-    """Register a view for the current widget.
-
-    This decorator can be used to expose a specific function below a widget's
-    URL endpoint. Refer to the "Widget-specific views" section in the
-    documentation to learn how to construct the corresponding URL.
+class Widget(object):
+    """
+    The main widget class, you must subclass it to create a widget.
+
+    Args:
+        name (str): The widget name. It will not be displayed in the UI, but
+            will appear in some URLs, so be careful to only use simple,
+            URL-compatible characters.
+        position (str): The position of the widget in the rendered page. It
+            should be one of the following values: 'left', 'right', or 'both'.
+        arguments (list): A list of dictionaries that describe a widget's
+            configuration. See `hubs.widgets.base.Argument`.
     """
-    def decorator(func):
-        options["view_func_name"] = func.__name__
-        mdict = sys.modules[func.__module__].__dict__
-        mroutes = mdict.setdefault('ROUTES', [])
-        mroutes.append(options)
-        return func
-    return decorator
+
+    name = None
+    position = None
+    arguments = []
+
+    def validate(self):
+        """Ensure that the widget has the bits it needs."""
+        if self.name is None:
+            raise AttributeError('Widgets must have a "name" attribute')
+        if not re.match('^[\w_.-]+$', self.name):
+            raise AttributeError(
+                'Invalid widget name: %r. ' % self.name +
+                'Please use URL-compatible characters.')
+        if self.position not in ['left', 'right', 'both']:
+            raise AttributeError(
+                '%r\'s "position" is not: `left`, `right` or `both`'
+                % self.name)
+        root_view = self.get_views().get("root")
+        if root_view is None:
+            raise AttributeError(
+                'Widgets must have a "root" view, please refer to the '
+                'documentation.')
+        if "/" not in root_view.url_rules:
+            raise AttributeError(
+                'The root view must be registered for the "/" URL rule.')
+
+    def get_arguments(self):
+        return [Argument(**arg) for arg in self.arguments]
+
+    def get_template_environment(self):
+        """
+        Get the template environment that widget-specific views will use.
+        """
+        # We may have widget-specific template environment one day
+        # (when widget templates are stored in the widget's directory
+        # instead of a common widget template directory).
+        # When that happens, it should be cached in a Widget attribute.
+        from hubs.widgets.templating import environment
+        return environment
+
+    def _get_local_subclasses(self, parent_class):
+        """
+        Returns the subclasses of the `parent_class` defined in this widget's
+        Python module.
+        """
+        result = []
+        widget_module = import_module(self.__module__)
+        for objname in dir(widget_module):
+            obj = getattr(widget_module, objname)
+            if type(obj) != type(object):
+                continue  # we only look for classes
+            if not issubclass(obj, parent_class):
+                continue  # we only want subclasses of the parent_class
+            if obj.__module__ != self.__module__:
+                # we don't want locally imported classes (like the
+                # parent_class itself)
+                continue
+            result.append(obj)
+        return result
+
+    def get_views(self):
+        """
+        Returns:
+            dict: A dictionary of the widget-specific views, indexed by their
+                `name` attribute.
+        """
+        return dict([
+            (view.name, view) for view in
+            self._get_local_subclasses(WidgetView)
+            ])
+
+    def register_routes(self, app):
+        """
+        Register the widget-specific views in the web framework.
+
+        Args:
+            app (flask.Flask): The Flask application to register the views
+                with.
+
+        This function is Flask-specific.
+        """
+        for view_name, view_class in self.get_views().items():
+            endpoint = "%s_%s" % (self.name, view_name)
+            view_func = view_class.as_view(endpoint, self)
+            for url_rule in view_class.url_rules:
+                rule = "/<hub>/w/%s/<int:idx>/%s" % (
+                    self.name, url_rule.lstrip("/"))
+                app.add_url_rule(rule, view_func=view_func)
+
+    def get_cached_functions(self):
+        """
+        Returns:
+            dict: A dictionary of the widget's cached functions, indexed by
+                their class name.
+        """
+        result = {}
+        for fn_class in self._get_local_subclasses(CachedFunction):
+            result[fn_class.__name__] = fn_class
+        return result

